using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace ComboGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(472, 328);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(352, 368);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 32);
			this.button1.TabIndex = 1;
			this.button1.Text = "ColumnNames";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 414);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable ComboTable = null;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = GetParentTable();
			
			this.gridDataBoundGrid1.DataSource = dt;

			this.gridDataBoundGrid1.ControllerOptions |= GridControllerOptions.DragColumnHeader; 

			this.gridDataBoundGrid1.PrepareViewStyleInfo +=new GridPrepareViewStyleInfoEventHandler(gridDataBoundGrid1_PrepareViewStyleInfo); 

			this.gridDataBoundGrid1.Model.Cols.FrozenCount = 4;

		
		}

		#region DataTables

		private int numberParentRows = 12;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("EmpNo"));
			dt.Columns.Add(new DataColumn("EmpName" ));
			dt.Columns.Add(new DataColumn("DeptNo"));
			dt.Columns.Add(new DataColumn("Salary" ,typeof(int)));
			
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = "EmpNo" + i; 
				dr[1] = "EmpName" + i; 
				dr[2] = "DeptNo" + i; 
				dr[3] = 1000 * 10 * i; 
				dt.Rows.Add(dr);
			}
		 


			return dt;
		}

				
		#endregion

		
		
		private void button1_Click(object sender, System.EventArgs e)
		{
			for(int i = 0;i< this.gridDataBoundGrid1.Model.ColCount;i++)
			{
				Console.WriteLine("MappingName  :  " + this.gridDataBoundGrid1.Binder.InternalColumns[i].MappingName);   
				Console.WriteLine("HeaderText   :  " +  this.gridDataBoundGrid1.Binder.InternalColumns[i].HeaderText );   
			}
			
		}

		private void gridDataBoundGrid1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			if( e.RowIndex > 0 && e.ColIndex > 0 )
			{
				GridDataBoundGrid grid = sender as GridDataBoundGrid; 
				int col = grid.Binder.NameToColIndex("Salary");  
				//If you want to set the readonly to whole row, you can use the Model object
				// otherwise you can use e.Style.Text.
				string stext = grid.Model[e.RowIndex,col].Text;
				if( stext != null && stext != string.Empty)
				{
					int iCellvalue = int.Parse(stext);    
					if( iCellvalue < 20000 )
					{
						e.Style.ReadOnly = true; 
						e.Style.BackColor = Color.Gray;
					}
					else
					{
						e.Style.ReadOnly = false;
						e.Style.BackColor = Color.AliceBlue ;
					}
				}
			}
		}

		
	}
}
